// ϢУ
// ϢУ
// ϢУ
// ϢУ
// ϢУ
// ϢУ
// ϢУ
// 2017-05-11
#include <stdio.h>
#include <stdlib.h>
#include <mqueue.h>    //Ϣ
#include <unistd.h>    //   (fork)
#include <semaphore.h> //ź
#include <sys/wait.h>  //wait
#include <fcntl.h>     //ϵͳдĺ

struct MsgType {
	int len;
	float pi;
};

sem_t mySem;

int main() {

	mqd_t msgq_id;
	struct MsgType msg;
	unsigned int prio;
	const char *file = "\\mqex1";

	int fpid = fork();   //һӽ

	// 븸
	if(fpid > 0)
	{
		msg.len = 8;
		msg.pi = 3.14159;

		// ½һϢ
		msgq_id = mq_open(file, O_RDWR | O_CREAT, S_IRWXU | S_IRWXG, NULL);
		printf("father : msg id is 0x%X.\n",(unsigned int)msgq_id);
		fflush(stdout);

		if (msgq_id == (mqd_t) -1) {
			perror("mq_open error");
			exit(1);
		}
		printf("father : send pi is %f.\n",msg.pi);
		fflush(stdout);

		// Ϣ
		if (mq_send(msgq_id, (char*) &msg, sizeof(struct MsgType), prio) == -1) {
			perror("mq_send");
			exit(1);
		}

		//ź
		sem_post(&mySem);

		// رϢ
		if (mq_close(msgq_id) == -1) {
			perror("mq_close");
			exit(1);
		}

		//ȴӽ
		//sleep(1);
		wait(NULL);

		// ɾϢлļ
		if (mq_unlink(file) == -1) {
			perror("mq_unlink");
			exit(1);
		}
	}

	//ӽ
	if(fpid == 0)
	{
		msg.len = 8;
		msg.pi = -1;
		printf("child : before recv msg, pi is %f.\n",msg.pi);
		fflush(stdout);

		// ½һϢ
		msgq_id = mq_open(file, O_RDWR | O_CREAT, S_IRWXU | S_IRWXG, NULL);
		printf("child : msg id is 0x%X.\n",(unsigned int)msgq_id);
		if (msgq_id == (mqd_t) -1) {
			perror("mq_open error");
			exit(1);
		}

		// ȴź
		sem_wait(&mySem);

		// Ϣ
		if (mq_receive(msgq_id, (char*) &msg, 8192, &prio) == -1) {
			perror("mq_receive");
			exit(1);
		}
		printf("child : recv pi is %f.\n",msg.pi);
		fflush(stdout);

		// رϢ
		if (mq_close(msgq_id) == -1) {
			perror("mq_close");
			exit(1);
		}
		/*
		if (mq_unlink(file) == -1) {
			perror("mq_unlink");
			exit(1);
		}
		*/
	}

	if(fpid<0)    //ӽʧ˳
	{
		perror("fork");
		exit(1);
	}

	return 0;
}

